!DIR$ FIXEDFORMLINESIZE:132
      subroutine check_sol(bsol, info)
      use blocks
      use formats
      implicit none

      integer*4, intent(in)  :: bsol(0:Nm1)
      integer*4, intent(out) :: info

      integer*4 x(0:Nm1)
      integer*4 i, i0, i1, j, k, fdist

      info = 0
      x = 0

      open(unit=70, file='mod.dat', status='old', err=1000)

      I  = 0
      I0 = 0
      I1 = 0

 1    continue

      read(70, *, err=1001, end=2) k, j
      I = I + 1
      if(I .ne. k) then
         write(6,f5) 'check_sol: "mod.dat" has incorrect 1st entry K=', K, ' in line I=', I
         info = -1
         return
      end if

      if      (j .eq. 0) then
         I0 = I0 + 1
      else if (j .eq. 1) then
         I1 = I1 + 1
      else
         write(6,f5) 'check_sol: "mod.dat" has incorrect 2nd entry J=', J, ' in line I=', I
         info = -2
         return
      end if

      goto 1
 2    continue
      close(unit=70)

      if(I0+I1 .ne. I) then
         write(6,f1) 'check_sol: Unexpected error I0+I1=/=I; exiting'
         info = -3
         return
      end if
         
      if(I .ne. N) then
         write(6,f5) 'check_sol: Number of lines in "mod.dat" I is =/=N; I=', I, ', N=', N
         info = -4
         return
      end if

      if(I1 .ne. N1) then
         write(6,f5) 'check_sol: Number of 1s in "mod.dat" I1 is =/=r; I1=', I1, ', r=', N1
         info = -5
         return
      end if
         
      open(unit=70, file='mod.dat', status='old',err=1000)
      do 3, i=0,Nm1
         read(70,*,end=1001,err=1001) k, j
         x(i) = j
 3    continue
      close(unit=70)

      info = fdist(x,bsol)
      return

 1000 continue
      write(6,f1) '> File "mod.dat" can not be open; exiting'
      info = -100
      return

 1001 continue
      write(6,f1) '> Error reading file "mod.dat"; exiting'
      info = -101
      return

      end
