c     p(x) = x*x*x + a*x*x + b*x + c ; a=A2; b=A1; c=A0
      pure subroutine solve_cubic(A0,A1,A2,z,k)
      implicit none

      real*8,    intent(in)  :: A0, A1, A2
      real*8,    intent(out) :: z(1:3)
      integer*4, intent(out) :: k

      real*8, parameter :: phi   = (8.0d0/3.0d0)*datan(1.0d0)
      real*8, parameter :: Third = 1.0d0/3.0d0
      real*8, parameter :: tiny  = 1.0d-12

      real*8 Q, Q3, R, R2, S, S3, A, B, A2o3, A2p2, A2p3, theta, D, Det

      z = 0.0d0

      A2o3 = A2/3.0d0
      A2p2 = A2*A2
      A2p3 = A2*A2p2

      Q = (A2p2 - 3.0d0*A1) / 9.0d0
      R = (2.0d0*A2p3 - 9.0d0*A2*A1 + 27.0d0*A0) / 54.0d0

      R2 = R*R
      Q3 = Q*Q*Q

      Det = R2 - Q3

      if(Det .ge. 0.0d0) then

         k = 1

         D = (dabs(R) + dsqrt(Det))**Third 

         if(R .lt. 0.0d0) then
            A =  D
         else 
            A = -D
         end if

         if(dabs(A) .gt. tiny) then
            B = Q/A
         else
            B = 0.0d0
         end if
         
         z(1) = A + B - A2o3

      else

         k = 3
         S  = dsqrt(Q)
         S3 = S*S*S
         theta = dacos(R/S3)/3.0d0
         S = 2.0d0*S
         z(1) = -(S*dcos(theta    ) + A2o3)
         z(2) = -(S*dcos(theta+phi) + A2o3)
         z(3) = -(S*dcos(theta-phi) + A2o3)

      end if


      end
